////////////////////////////////////////////////////////////////////////////
// CTaEditShell 饹Υץơ
//
////////////////////////////////////////////////////////////////////////////

#include "TaEditShell.h"
#include "TaEditDraw.h"
#include "TaEditVScroll.h"
#include "TaEditHScroll.h"
#include "lang/TxtColorMgr.h"
#include "Thread.h"
#include "CmdEnv.h"
#include "CompoundStr.h"
#include "Consruction.h"
#include "ProcStart.h"
#include "EncodeInfo.h"
#include "TitleMgr.h"
#include <locale.h>
#include <sys/wait.h>


////////////////////////////////////////////////////////////////////////////
// /˴
////////////////////////////////////////////////////////////////////////////

CTaEditShell::CTaEditShell() :
	CAppShell(),
	theDocument(),
	MsgBoxMgr(),
	pConfigInfo( NULL ),
	m_CmdOption(),
	pLangConfig( NULL ),
	m_Plugin(),
	IconPixmap( XmUNSPECIFIED_PIXMAP ),
	CursorTimerID( 0 ),
	pConstruction( NULL ),
	TitleMgr()
{

}

CTaEditShell::~CTaEditShell()
{

}

////////////////////////////////////////////////////////////////////////////
// ᥽å
////////////////////////////////////////////////////////////////////////////

////////////////////////////////////////////////////////////////////////////
// 

// ۤȤƤФ  OnCreateᤤ
void CTaEditShell::create( Display *display, char *app_name, int app_argc, char **app_argv, char *app_class_name )
{
	// ޥɥ饤Υץ᤹
	m_CmdOption.SetOption( app_argc, app_argv );

	CAppShell::create( display, app_name, app_argc, app_argv, app_class_name );
}

// ̾Ρ
// ƤФʳǤϡm_Draw,m_HScroll,m_VScrollγƥ饹Υ󥹥󥹤
// ƤϤ뤬Ƽ復åȤƤʤ
void CTaEditShell::OnCreate( Widget argWgt, XtPointer client_data )
{
	int ac = 0;
	Arg al[20];
	Widget wWgt;
	CCompoundStr TitleStr( "Syuhitu" );
	XtAppContext appContext = XtWidgetToApplicationContext( m_TaEditShell );

	// 󥪥֥Ȥۡ
	pConfigInfo = new CConfigInfo( argWgt );
	if ( !pConfigInfo ) {
		fprintf( stderr, "Syuhitu : Out of memory.\n" );
		ExitProcess( 1 );
	}
	pConfigInfo->Initialize();

	// ̾󥪥֥Ȥۤ
	pLangConfig = new NLangExt::CLangConfig( pConfigInfo );

	// åܥå֥Ȥν
	MsgBoxMgr.Initialize( argWgt, (*pConfigInfo) );

	theDocument.Initialize();

	// Υѥǥ󥰤
	unsigned int LeftPadding = pConfigInfo->GetLeftPadding();
	unsigned int RightPadding = pConfigInfo->GetRightPadding();
	m_HScroll->SetPadding( LeftPadding, RightPadding );

	// ɥåȤ륯饹
	// СΥ٥ȥϥɥȤϿ
	m_HScroll->SetEventHandler( m_Draw );
	m_VScroll->SetEventHandler( m_Draw );

	// ɥåȤˡСδ֥Ȥ
	m_Draw->SetScrollMgr( m_HScroll, m_VScroll );

	// ޤ
	CursorTimerID = XtAppAddTimeOut( appContext, 500, CTaEditShell::OnTimer, this );

	// ư¸ѤΥޤ
	if ( pConfigInfo->GetAutoSaveInterval() > 0 )
		XtAppAddTimeOut( appContext, pConfigInfo->GetAutoSaveInterval() * 1000,
			CTaEditShell::OnAutoSaveTimer, this );

	// ɥõȤΥǥեȤνߤ
	ac = 0;
	XtSetArg( al[ac], XmNdeleteResponse, XmDO_NOTHING ); ac++;
	XtSetValues( m_TaEditShell, al, ac );

	// ץưȤΥޥɤ¹
	const string &rProcUpScript = pConfigInfo->RefProcUpScript();
	if ( !rProcUpScript.empty() ) {
		if ( system( rProcUpScript.c_str() ) < 0 )
			ProcErrorMsg( pConfigInfo->RefRunScriptErrnoMsg( errno ) );
	}
}

// Ʋ̤ɽȤƤФ
void CTaEditShell::OnFirstExpose()
{
	int ac = 0;
	Arg al[20];
	CErrorBool r;
	Dimension x, y;
	int sw, sh;	// ꡼
	int cw, ch;	// ɥȹ⤵

	// 
	if ( !pConfigInfo->RefIconImageName().empty() ) {
		// ѥ᡼ɤ߹
		const string& rIconImageName = pConfigInfo->RefIconImageName();
		Display *pDisplay = XtDisplay( m_TaEditShell );
		Window window = XtWindow( m_TaEditShell );
		Screen *screen = XtScreen( m_TaEditShell );
		Pixel black = BlackPixelOfScreen( screen );
		Pixel white = WhitePixelOfScreen( screen );
		IconPixmap = XmGetPixmap( screen, const_cast< char* >( rIconImageName.c_str() ), black, white );
		if ( IconPixmap != XmUNSPECIFIED_PIXMAP ) {
			// ᡼ɤ߹ߤ顢ꤹ
			ac = 0;
			XtSetArg( al[ac], XmNiconPixmap, IconPixmap ); ac++;
			XtSetValues( m_TaEditShell, al, ac );
		}
	}

	if ( m_CmdOption.IsConstructionMode() )
		// 󥹥ȥ饯󡦥⡼ɤˤ
		ProcErrorMsg( SetConstructionMode() );
	else
		SetCSModeMenu();	// ˥塼ɽꤹ

	// ץ饰ν
	r = m_Plugin.ConfigurePlugin( pConfigInfo->RefPluginConfigFileName(), m_cascadeTool, m_menuTool, m_Draw );
	ProcErrorMsg( r );

	// ߤΥɥΰ֤
	ac = 0;
	XtSetArg(al[ac], XmNx, &x ); ac++;
	XtSetArg(al[ac], XmNy, &y ); ac++;
	XtGetValues( m_TaEditShell, al, ac );

	// ꡼Υ
	sw = WidthOfScreen( XtScreen( m_TaEditShell ) );
	sh = HeightOfScreen( XtScreen( m_TaEditShell ) );

	// ꤵ줿ȹ⤵
	cw = pConfigInfo->GetWindowWidth();
	ch = pConfigInfo->GetWindowHeight();

	// ɥΰ֡⤵
	if ( cw < 100 ) cw = 100;
	if ( ch < 100 ) ch = 100;
	if ( cw >= sw - 50 ) cw = sw - 50;
	if ( ch >= sh - 50 ) ch = sh - 50;
	if ( x + cw >= sw ) x = 0;
	if ( y + ch >= sh ) y = 0;
	if ( x < 0 ) x = 0;
	if ( y < 0 ) y = 0;
	ac = 0;
	XtSetArg(al[ac], XmNwidth, cw ); ac++;
	XtSetArg(al[ac], XmNheight, ch ); ac++;
	XtSetArg(al[ac], XmNx, x ); ac++;
	XtSetArg(al[ac], XmNy, y ); ac++;
	XtSetValues( m_TaEditShell, al, ac );

	// ִ˥ӥ塼֥ȤΥɥ쥹
	m_FindShell->SetDrawObj( m_Draw );

	// ȥ֥Ȥ
	TitleMgr.Initialize( pConfigInfo, &theDocument, m_Draw );
}

////////////////////////////////////////////////////////////////////////////
// ˥塼Υ٥ȥϥɥ

// ̾դ¸
void CTaEditShell::OnWriteFile( Widget argWgt, XtPointer client_data )
{
	WriteFileProcedure();
}

// ¸
void CTaEditShell::OnSaveFile( Widget argWgt, XtPointer client_data )
{
	SaveFileProcedure();
}

// 
void CTaEditShell::OnOpenFile( Widget argWgt, XtPointer client_data )
{
	OpenFile( "" );
}

// 
void CTaEditShell::OnNewFile( Widget argWgt, XtPointer client_data )
{
	// ¸̵ͭǧ
	if ( !MakeSure_FileSave() ) return ;

	// ФˡԤ뤳ȤΤ
	if ( pConstruction ) {
		bool cf = true;
		CErrorBool sr = pConstruction->ChangeFileName( "", &cf );
		if ( !sr ) ProcErrorMsg( sr );
		if ( cf ) return ;
	}

	// ޤǤΥե뤬˴뤿ᡢ
	// ե뤬ĤȤΥޥɤ¹Ԥ롣
	if ( !RunFileCloseScript() ) return ;

	// 
	theDocument.Initialize();

	// ӥ塼ɽ򹹿
	m_Draw->OnReadDocument();
}

// λ˥塼
void CTaEditShell::OnCloseAppMenu( Widget argWgt, XtPointer client_data )
{
	OnClose( argWgt, client_data );	// λ
}

// Text⡼ɤѹ
void CTaEditShell::SetFileTypeTXT( Widget argWgt, XtPointer client_data )
{
	CErrorBool r;
	bool IsUpdate;
	r = theDocument.SetTxtColorMgr( LANGTYPE_TEXT, &IsUpdate );
	if ( IsUpdate ) m_Draw->OnReadDocument();
	ProcErrorMsg( r );
}

// C/C++⡼ɤѹ
void CTaEditShell::SetFileTypeCPP( Widget argWgt, XtPointer client_data )
{
	CErrorBool r;
	bool IsUpdate;
	r = theDocument.SetTxtColorMgr( LANGTYPE_CPP, &IsUpdate );
	if ( IsUpdate ) m_Draw->OnReadDocument();
	ProcErrorMsg( r );
}

// Java⡼ɤѹ
void CTaEditShell::SetFileTypeJAVA( Widget argWgt, XtPointer client_data )
{
	CErrorBool r;
	bool IsUpdate;
	r = theDocument.SetTxtColorMgr( LANGTYPE_JAVA, &IsUpdate );
	if ( IsUpdate ) m_Draw->OnReadDocument();
	ProcErrorMsg( r );
}

// COBOL⡼ɤѹ
void CTaEditShell::SetFileTypeCBL( Widget argWgt, XtPointer client_data )
{
	CErrorBool r;
	bool IsUpdate;
	r = theDocument.SetTxtColorMgr( LANGTYPE_CBL, &IsUpdate );
	if ( IsUpdate ) m_Draw->OnReadDocument();
	ProcErrorMsg( r );
}

// VBScript⡼ɤѹ
void CTaEditShell::SetFileTypeVBS( Widget argWgt, XtPointer client_data )
{
	CErrorBool r;
	bool IsUpdate;
	r = theDocument.SetTxtColorMgr( LANGTYPE_VBS, &IsUpdate );
	if ( IsUpdate ) m_Draw->OnReadDocument();
	ProcErrorMsg( r );
}

// JavaScript⡼ɤѹ
void CTaEditShell::SetFileTypeJS( Widget argWgt, XtPointer client_data )
{
	CErrorBool r;
	bool IsUpdate;
	r = theDocument.SetTxtColorMgr( LANGTYPE_JS, &IsUpdate );
	if ( IsUpdate ) m_Draw->OnReadDocument();
	ProcErrorMsg( r );
}

// C#⡼ɤѹ
void CTaEditShell::SetFileTypeCS( Widget argWgt, XtPointer client_data )
{
	CErrorBool r;
	bool IsUpdate;
	r = theDocument.SetTxtColorMgr( LANGTYPE_CS, &IsUpdate );
	if ( IsUpdate ) m_Draw->OnReadDocument();
	ProcErrorMsg( r );
}

// HTML⡼ɤѹ
void CTaEditShell::SetFileTypeHTML( Widget argWgt, XtPointer client_data )
{
	CErrorBool r;
	bool IsUpdate;
	r = theDocument.SetTxtColorMgr( LANGTYPE_HTML, &IsUpdate );
	if ( IsUpdate ) m_Draw->OnReadDocument();
	ProcErrorMsg( r );
}

// 󥹥ȥ饯⡼ɤѹ
void CTaEditShell::OnConstruction( Widget argWgt, XtPointer client_data )
{
	int ac = 0;
	Arg al[2];
	Boolean flg;

	// ȥͤ
	ac = 0;
	XtSetArg( al[ac], XmNset, &flg ); ac++;
	XtGetValues( m_menuCSModeConstruction, al, ac );

	// ȥ뤬offˤ줿Ȥϲ⤷ʤ
	if ( !flg ) return ;

	// 󥹥ȥ饯󡦥⡼ɤѹ
	ProcErrorMsg( SetConstructionMode() );
}

// ɥ⡼ɤѹ
void CTaEditShell::OnStandalone( Widget argWgt, XtPointer client_data )
{
	int ac = 0;
	Arg al[2];
	Boolean flg;

	// ȥͤ
	ac = 0;
	XtSetArg( al[ac], XmNset, &flg ); ac++;
	XtGetValues( m_menuCSModeStandalone, al, ac );

	// ȥ뤬offˤ줿Ȥϲ⤷ʤ
	if ( !flg ) return ;

	// ɥ󡦥⡼ɤѹ
	ProcErrorMsg( SetStandaloneMode() );
}

// Խ˥塼ɽ
void CTaEditShell::OnEditMenuShow( Widget argWgt, XtPointer client_data )
{
}

// ɥ˥塼
void CTaEditShell::OnEditRedo( Widget argWgt, XtPointer client_data )
{
	if ( !theDocument.EnableRedo() )
		return ;
	m_Draw->GetTextEditor()->Redo();
}

// ɥ˥塼
void CTaEditShell::OnEditUndo( Widget argWgt, XtPointer client_data )
{
	// ˥塼̵ˤʤäƤ⡢Ctrl+ZˤƤФǽ
	if ( !theDocument.EnableUndo() ) return ;
	m_Draw->GetTextEditor()->Undo();
}

// ڤ˥塼
void CTaEditShell::OnEditCut( Widget argWgt, XtPointer client_data )
{
	m_Draw->GetTextEditor()->Cut();
}

// ԡ˥塼
void CTaEditShell::OnEditCopy( Widget argWgt, XtPointer client_data )
{
	m_Draw->GetTextEditor()->Copy();
}

// ĥդ˥塼
void CTaEditShell::OnEditPaste( Widget argWgt, XtPointer client_data )
{
	m_Draw->GetTextEditor()->Paste();
}

// ˥塼
void CTaEditShell::OnEditFullSelect( Widget argWgt, XtPointer client_data )
{
	m_Draw->GetTextEditor()->FullSelect();
}

// ִ˥塼
void CTaEditShell::OnEditFind( Widget argWgt, XtPointer client_data )
{
	m_FindShell->ShowDlg();
}

// Ԥذư
void CTaEditShell::OnEditMoveto( Widget argWgt, XtPointer client_data )
{
	m_Draw->GetTextEditor()->OnMoveto();
}

// ɥĤ
void CTaEditShell::OnClose( Widget argWgt, XtPointer client_data )
{
	int r = 0;

	// Shell̵ˤʤäƤȤ㤨ХåܥåɽƤˤϡ
	// λԤʤ
	if ( !XtIsSensitive( m_TaEditShell ) ) return ;

	// ե¸ǧƤ齪λ
	if ( MakeSure_FileSave() ) {
		// ե뤬ĤȤΥޥɤ¹Ԥ롣
		RunFileCloseScript();

		// ץλȤ˼¹Ԥ륳ޥɤ¹Ԥ롣
		const string &rProcDownScript = pConfigInfo->RefProcDownScript();

		if ( !rProcDownScript.empty() ) {
			CCmdEnv cmdenv;
			r = cmdenv.Run( rProcDownScript.c_str() );
			if ( r < 0 )
				ProcErrorMsg( pConfigInfo->RefRunScriptErrnoMsg( errno ) );
		}

		// Ȥꤢѥ᡼
		if ( IconPixmap != XmUNSPECIFIED_PIXMAP )
			XmDestroyPixmap( XtScreen( m_TaEditShell ), IconPixmap );
		IconPixmap = XmUNSPECIFIED_PIXMAP;

		// λ
		ExitProcess( r );
	}
}

// ɥåɥɥåפ줿ե򳫤
void CTaEditShell::OpenDnDFiles( int cnt, char **pFileName )
{
	assert( this );

	int idx;
	int r;
	int NewWndLine = pConfigInfo->GetLineNumberOrigin();

	// Shell̵ˤʤäƤȤ㤨ХåܥåɽƤˤϡ
	// ɥåɥɥåפʤ
	if ( !XtIsSensitive( m_TaEditShell ) ) return ;

	if ( cnt <= 0 ) return ;

	if ( pConfigInfo->GetDropFileOpenMethod() == DFOM_CURRENT_WINDOW ) {
		// ǽΥե򡢥ȤΥɥǳ
		OpenFile( pFileName[0] );	// ǽΥե򳫤
		idx = 1;
	}
	else
		idx = 0;

	for (; idx < cnt; idx++ ) {
		// ʹߤΥեϡ˴ؤ餺ɥǳ
		if ( !OpenFileInNewWindow( pFileName[idx], NewWndLine, "", "" ) )
			return ;
	}
}

////////////////////////////////////////////////////////////////////////////
// åܥåν

// 
void CTaEditShell::ShowInformationMsgBox( const CCompoundStr &rStr ) const
{
	MsgBoxMgr.ShowInformationMsgBox( rStr );
}

// 
int CTaEditShell::ShowQuestionMsgBox( const CCompoundStr &rStr, bool ShowCancel ) const
{
	return MsgBoxMgr.ShowQuestionMsgBox( rStr, ShowCancel );
}

// 顼
void CTaEditShell::ShowErrorMsgBox( const CCompoundStr &rStr ) const
{
	MsgBoxMgr.ShowErrorMsgBox( rStr );
}

////////////////////////////////////////////////////////////////////////////
// եϽ

// ե¸ɬפ뤫ݤǧ
// ߤϵ֤
bool CTaEditShell::MakeSure_FileSave()
{
	if ( !theDocument.GetIsModify() )
		return true;	// ¸ɬפϤʤ

	// ǧ
	int r = ShowQuestionMsgBox( pConfigInfo->RefPreservationCheckMsg(), true );
	assert( r >= 1 && r <= 3 );

	switch ( r ) {
	case 1:	// Yes
		return SaveFileProcedure();	// ¸롣
	case 2:	// No
		return true;	// ¸ɬפϤʤ
	case 3:	// Cancel
		return false;	// ߤ
	}
	return true;
}

// եξ¸ν
bool CTaEditShell::SaveFileProcedure()
{
	bool ColChanged;
	CErrorBool r;
	CEncodeInfo CurrentEncodeInfo;
	string OldFileName = theDocument.GetFileName();	// Υե̾
	CEncodeInfo OldEncodeInfo = theDocument.GetEncodeInfo();	// Υ󥳡ɾ

	if ( theDocument.GetFileName() == "" ) {
		// ̾դƤʤϡ̾դ¸פνԤ
		return WriteFileProcedure();
	}

	// ե񤭹˼¹Ԥ륳ޥɤ¹Ԥ
	if ( !RunFileBeforeWriteScript( OldFileName, OldEncodeInfo ) );

	// Ϥ
	CurrentEncodeInfo = theDocument.GetEncodeInfo();	// ߤΥեΥ󥳡ɤ򤽤Τޤ޻Ѥ
	r = theDocument.OnSaveDocument( theDocument.GetFileName(), &ColChanged, CurrentEncodeInfo );
	if ( !r ) {
		ProcErrorMsg( r );
		return false;
	}

	if ( ColChanged ) {
		// 󤬹줿顢ӥ塼ˤΤȤΤ
		m_Draw->OnReadDocument();
	}
	else {
		// ѲʤäˤϡȤꤢɬ׺Ǿ¤κ»ܤƤ
		int s = m_Draw->GetTopLineNum();
		int cnt = m_Draw->GetViewLineCnt();
		m_Draw->AfterSelRangeRedraw( s, s + cnt );
	}

	// ե񤭹ȤΥޥɤ¹
	RunFileWriteScript( OldFileName, OldEncodeInfo );
	return true;
}

// ե̾դ¸
bool CTaEditShell::WriteFileProcedure( )
{
	CEncodeInfo CurLocale;
	CurLocale.Initialize();
	return WriteFile( "", CurLocale );
}

// ե̾ꤷƥե¸
// ե̾ꤵʤäˤϡɽơե̾
bool CTaEditShell::WriteFile( const string &rFileName, const CEncodeInfo &rEncodeInfo )
{
	bool ColChanged;
	CErrorBool r;
	string SelectedFile;
	CEncodeInfo SelectedEncodeInfo;
	string OldFileName = theDocument.GetFileName();	// ϤΥե̾򤷤Ƥ
	CEncodeInfo OldEncodeInfo = theDocument.GetEncodeInfo();

	m_FileSelectShell->SetDlgTitle( pConfigInfo->RefFileSaveDlgTitle(), false );
	m_FileSelectShell->SetDefaultEncodeInfo( theDocument.GetEncodeInfo() );

	// ɽ
	if ( rFileName.length() == 0 ) {
		if ( !m_FileSelectShell->ShowDlg() )
			return false;
		// 򤵤줿ͤ
		SelectedFile = m_FileSelectShell->GetSelectedFileName();
		SelectedEncodeInfo = m_FileSelectShell->GetSelectedEncodeInfo();
	}
	else {
		SelectedFile = rFileName;
		SelectedEncodeInfo = rEncodeInfo;
	}

	// Фˡ̾դ¸Ԥ뤳ȤΤ
	if ( pConstruction ) {
		bool cf = false;
		CErrorBool sr = pConstruction->QueryWriteFile( SelectedFile, &cf );
		if ( !sr ) ProcErrorMsg( sr );
		if ( cf ) return true;
	}

	// ե¸Υޥɤ¹Ԥ
	if ( !RunFileBeforeWriteScript( SelectedFile, SelectedEncodeInfo ) ) return false;

	// ¸
	r = theDocument.OnSaveDocument( SelectedFile, &ColChanged, SelectedEncodeInfo );
	if ( !r ) {
		ProcErrorMsg( r );
		return false;
	}

	// Фˡե̾ѹȤΤ
	if ( pConstruction ) {
		bool cf = false;
		CErrorBool sr = pConstruction->ChangeFileName( theDocument.GetFileName(), &cf );
		if ( !sr ) ProcErrorMsg( sr );
	}

	// ¸Ǥ饿ȥꤹ롣
	ResetTitle( TITLESTR_ALL );

	// ե񤭹߸Υޥɤ¹
	RunFileWriteScript( OldFileName, OldEncodeInfo );

	// ե̾ѹȤȤˡ
	// ¸󥪥֥Ȥǽ뤿ᡣ
	if ( ColChanged ) m_Draw->OnReadDocument();

	return true;	
}

// ե򳫤
// ե̾ꤵʤäϡɽƥե̾
bool CTaEditShell::OpenFile( const string &rFileName, enumLANGTYPE LangType, const string &rEncodeName )
{
	string SelectedFile;
	CEncodeInfo SelectedEncodeInfo;
	bool IsChanged = false;

	// ¸̵ͭǧ
	if ( !MakeSure_FileSave() ) return false;

	if ( rFileName.empty() ) {
		// ե̾ꤵƤʤäϡ֥ե򳫤ץɽơ
		// 桼˥ե̾䤤碌롣
		m_FileSelectShell->SetDlgTitle( pConfigInfo->RefFileOpenDlgTitle(), true );
		if ( !m_FileSelectShell->ShowDlg() )
			return false;
		SelectedFile = m_FileSelectShell->GetSelectedFileName();
		SelectedEncodeInfo = m_FileSelectShell->GetSelectedEncodeInfo();
	}
	else {
		// ե̾ꤵ졢ĥ󥳡̾ꤵʤäˤϡ
		// ȤΥΥ󥳡ɤѤ
		SelectedFile = rFileName;
		if ( rEncodeName.length() == 0 )
			SelectedEncodeInfo.Initialize();
		else
			SelectedEncodeInfo = CEncodeInfo( rEncodeName, CRTYPE_LF );
	}

	// ե򳫤Ȥ򥵡ФΤ
	if ( pConstruction ) {
		bool cf = false;
		CErrorBool sr = pConstruction->QueryOpenFile( SelectedFile, &cf );
		if ( !sr ) ProcErrorMsg( sr );
		if ( cf ) return true;
	}

	// ޤǤΥե뤬˴뤿ᡢե뤬ĤȤΥޥɤ¹Ԥ롣
	if ( !RunFileCloseScript() ) return false;

	// եɤ߹ȤΥޥɤ¹
	if ( !RunFileReadScript( SelectedFile, SelectedEncodeInfo ) ) return false;

	// ե볫
	CErrorBool r = theDocument.OnOpenDocument( SelectedFile, &IsChanged, LangType, SelectedEncodeInfo );

	// ɤ߹᤿顢եɤ߹߸˼¹Ԥ륳ޥɤ¹Ԥ롣
	if ( r ) RunFileAfterReadScript( SelectedFile, SelectedEncodeInfo );

	// 餫ͳǥɥȤƤѲʤСΤޤ޽λ롣
	if ( !IsChanged ) {
		ProcErrorMsg( r );
		return false;
	}

	// եɤ߹ӥ塼򹹿롣
	// ʥɥȤѹäϡ
	// νλޤǥåܥåɽƤϤʤ
	m_Draw->OnReadDocument();

	// Фˡե̾ѹȤΤ
	if ( pConstruction ) {
		bool cf = false;
		CErrorBool sr = pConstruction->ChangeFileName( theDocument.GetFileName(), &cf );
		if ( !sr ) ProcErrorMsg( sr );
	}

	// ɬפ˱ƥåɽ
	return ProcErrorMsg( r );
}

// ե뤬ɤ߹ޤȤΥޥɤ¹
bool CTaEditShell::RunFileReadScript( const string& rFileName, const CEncodeInfo &rEncodeInfo ) const
{
	const string &rScr = pConfigInfo->RefFileReadScript();
	CCmdEnv cmdenv;
	if ( rScr.empty() ) return true;

	// Ķѿ
	cmdenv.AddEnvironment( "TAEDIT_FILE_NAME", rFileName.c_str() );
	cmdenv.AddEnvironment( "TAEDIT_ENCODE_NAME", rEncodeInfo.GetEncodeName().c_str() );
	cmdenv.AddEnvironment( "TAEDIT_CRTYPE", rEncodeInfo.GetCRTypeName() );

	// ޥɤ¹
	int r = cmdenv.Run( rScr.c_str() );

	// ֤ͤäƤϡ顼Ȥ롣
	if ( r < 0 ) {
		ProcErrorMsg( pConfigInfo->RefRunScriptErrnoMsg( errno ) );
		return true;	// ȤꤢΤޤ޿ʤ
	}

	// ץȤμ¹Է̤ξɤ߹ߤ򥭥󥻥뤹
	if ( r >= 1 ) {
		if ( pConfigInfo->GetShowCancelOpenMsg() )
			ProcErrorMsg( pConfigInfo->RefRunScriptCancelOpenMsg() );
		return false;
	}
	return true;
}

// ե뤬ɤ߹ޤ줿ȤΥޥɤ¹
bool CTaEditShell::RunFileAfterReadScript( const string& rFileName, const CEncodeInfo &rEncodeInfo ) const
{
	const string &rScr = pConfigInfo->RefFileAfterReadScript();
	CCmdEnv cmdenv;
	if ( rScr.empty() ) return true;

	// Ķѿ
	cmdenv.AddEnvironment( "TAEDIT_FILE_NAME",rFileName.c_str() );
	cmdenv.AddEnvironment( "TAEDIT_ENCODE_NAME", rEncodeInfo.GetEncodeName().c_str() );
	cmdenv.AddEnvironment( "TAEDIT_CRTYPE", rEncodeInfo.GetCRTypeName() );

	// ޥɤ¹
	int r = cmdenv.Run( rScr.c_str() );

	// ֤ͤäƤϡ顼Ȥ롣
	if ( r >= 0 ) return true;
	ProcErrorMsg( pConfigInfo->RefRunScriptErrnoMsg( errno ) );
	return false;
}

// ե뤬ĤȤΥޥɤ¹
bool CTaEditShell::RunFileCloseScript() const
{
	const string &rScr = pConfigInfo->RefFileCloseScript();
	CCmdEnv cmdenv;
	const string &rFName = theDocument.GetFileName();
	const CEncodeInfo &rEncodeInfo = theDocument.GetEncodeInfo();

	if ( rScr.empty() ) return true;

	// Ķѿ
	cmdenv.AddEnvironment( "TAEDIT_FILE_NAME", rFName.c_str() );
	cmdenv.AddEnvironment( "TAEDIT_FILE_MODIFIED", theDocument.GetIsModify() ? "TRUE" : "FALSE" );
	cmdenv.AddEnvironment( "TAEDIT_ENCODE_NAME", rEncodeInfo.GetEncodeName().c_str() );
	cmdenv.AddEnvironment( "TAEDIT_CRTYPE", rEncodeInfo.GetCRTypeName() );

	// ޥɤ¹
	int r = cmdenv.Run( rScr.c_str() );

	// ֤ͤäƤϡ顼Ȥ롣
	if ( r >= 0 ) return true;

	ProcErrorMsg( pConfigInfo->RefRunScriptErrnoMsg( errno ) );
	return false;
}

// ե뤬ϤȤΥޥɤ¹
bool CTaEditShell::RunFileBeforeWriteScript( const string& NewFileName, const CEncodeInfo &rNewEncodeInfo ) const
{
	const string &rScr = pConfigInfo->RefFileBeforeWriteScript();
	CCmdEnv cmdenv;
	const string &rOldFName = theDocument.GetFileName();
	const CEncodeInfo &rOldEncodeInfo = theDocument.GetEncodeInfo();

	if ( rScr.empty() ) return true;

	// Ķѿ
	cmdenv.AddEnvironment( "TAEDIT_OLD_FILE_NAME", rOldFName.c_str() );
	cmdenv.AddEnvironment( "TAEDIT_OLD_ENCODE_NAME", rOldEncodeInfo.GetEncodeName().c_str() );
	cmdenv.AddEnvironment( "TAEDIT_OLD_CRTYPE", rOldEncodeInfo.GetCRTypeName() );
	cmdenv.AddEnvironment( "TAEDIT_NEW_FILE_NAME", NewFileName.c_str() );
	cmdenv.AddEnvironment( "TAEDIT_NEW_ENCODE_NAME", rNewEncodeInfo.GetEncodeName().c_str() );
	cmdenv.AddEnvironment( "TAEDIT_NEW_CRTYPE", rNewEncodeInfo.GetCRTypeName() );

	// ޥɤ¹
	int r = cmdenv.Run( rScr.c_str() );

	// ֤ͤäƤϡ顼Ȥ롣
	if ( r < 0 ){
		ProcErrorMsg( pConfigInfo->RefRunScriptErrnoMsg( errno ) );
		return true;	// Ȥꤢ³ԤΤȤ
	}

	// ץȤμ¹Է̤ξϽ񤭹ߤ򥭥󥻥뤹
	if ( r >= 1 ) {
		if ( pConfigInfo->GetShowCancelSaveMsg() )
			ProcErrorMsg( pConfigInfo->RefRunScriptCancelSaveMsg() );
		return false;
	}
	return true;
}

// ե뤬Ϥ줿ȤΥޥɤ¹
bool CTaEditShell::RunFileWriteScript( const string& OldFileName, const CEncodeInfo &rOldEncodeInfo ) const
{
	const string &rScr = pConfigInfo->RefFileWriteScript();
	CCmdEnv cmdenv;
	const string &rNewFName = theDocument.GetFileName();
	const CEncodeInfo &rNewEncodeInfo = theDocument.GetEncodeInfo();

	if ( rScr.empty() ) return true;

	// Ķѿ
	cmdenv.AddEnvironment( "TAEDIT_OLD_FILE_NAME", OldFileName.c_str() );
	cmdenv.AddEnvironment( "TAEDIT_OLD_ENCODE_NAME", rOldEncodeInfo.GetEncodeName().c_str() );
	cmdenv.AddEnvironment( "TAEDIT_OLD_CRTYPE", rOldEncodeInfo.GetCRTypeName() );
	cmdenv.AddEnvironment( "TAEDIT_NEW_FILE_NAME", rNewFName.c_str() );
	cmdenv.AddEnvironment( "TAEDIT_NEW_ENCODE_NAME", rNewEncodeInfo.GetEncodeName().c_str() );
	cmdenv.AddEnvironment( "TAEDIT_NEW_CRTYPE", rNewEncodeInfo.GetCRTypeName() );

	// ޥɤ¹
	int r = cmdenv.Run( rScr.c_str() );

	// ֤ͤäƤϡ顼Ȥ롣
	if ( r >= 0 ) return true;
	ProcErrorMsg( pConfigInfo->RefRunScriptErrnoMsg( errno ) );
	return false;
}


////////////////////////////////////////////////////////////////////////////
// ¾

// ɥȥ֥Ȥλ
CTaEditDoc *CTaEditShell::GetDocument()
{
	return &theDocument;
}

// Խ֥Ȥ
VClsPtr< CTextEdit > CTaEditShell::GetTextEditor()
{
	return m_Draw->GetTextEditor();
}

// ޥɹԥץ󥪥֥Ȥλ
const CCmdOption& CTaEditShell::GetCmdOption() const
{
	return m_CmdOption;
}

// ޥ٥ȤΥȥѴؿ
void CTaEditShell::OnTimer( XtPointer client_data, XtIntervalId *timer )
{
	reinterpret_cast< CTaEditShell* >( client_data )->OnTimer();
}

// ޥ٥
void CTaEditShell::OnTimer()
{
	XtAppContext appContext = XtWidgetToApplicationContext( m_TaEditShell );

	// ɥåȤˡޥ٥Ȥ롣
	m_Draw->OnTimer();

	// Υޤꤹ롣
	CursorTimerID = XtAppAddTimeOut( appContext, 500, CTaEditShell::OnTimer, this );
}

// 󥪥֥Ȥλ
VClsPtr< CConfigInfo > CTaEditShell::GetConfigInfo()
{
	return pConfigInfo;
}

// ԡڤ˥塼̵ͭꤹ
void CTaEditShell::SetEnableCopyPasteMenu( bool flg ) const
{
	XtSetSensitive( m_menuEditCut, flg ? True : False );
	XtSetSensitive( m_menuEditCopy, flg ? True : False );
}

// Undo˥塼̵ͭꤹ
void CTaEditShell::SetEnableUndoMenu( bool flg ) const
{
	XtSetSensitive( m_menuEditUndo, flg ? True : False );
}

// Redo˥塼̵ͭꤹ
void CTaEditShell::SetEnableRedoMenu( bool flg ) const
{
	XtSetSensitive( m_menuEditRedo, flg ? True : False );
}

// ԡڤ˥塼̵ͭ
bool CTaEditShell::GetEnableCopyPasteMenu() const
{
	return XtIsSensitive( m_menuEditCut ) && XtIsSensitive( m_menuEditCopy );
}

// Undo˥塼̵ͭ
bool CTaEditShell::GetEnableUndoMenu() const
{
	return XtIsSensitive( m_menuEditUndo );
}

// Redo˥塼̵ͭ
bool CTaEditShell::GetEnableRedoMenu() const
{
	return XtIsSensitive( m_menuEditRedo );
}

// ɬפ˱ƥ顼åɽ
bool CTaEditShell::ProcErrorMsg( CErrorBool r ) const
{
	if ( r ) return true;	// åɽɬפʤ
	ShowErrorMsgBox( r );	// åɽ
	return false;
}

// ̾󥪥֥Ȥ
const NLangExt::CLangConfig* CTaEditShell::GetLangConfig() const
{
	return pLangConfig;
}

// ץ饰֥Ȥ򻲾
CPlugin& CTaEditShell::RefPluginMgr()
{
	return m_Plugin;
}

// ɥ򳫤
// ե̾ꤵʤäϡե롣
bool CTaEditShell::OpenFileInNewWindow( const string &rfile, int Line, const string &rEncode, const string &LangType )
{
	CProcStart procStart;

	if ( pConstruction ) {
		// 󥹥ȥ饯󡦥⡼ɤξϡɮεư򥵡Ф˰ꤹ
		bool ComplateFlg = false;
		CErrorBool r = pConstruction->OpenFileWithNewWnd( rfile, Line, rEncode, LangType, &ComplateFlg );
		return ProcErrorMsg( r );
	}

	procStart.SpecifyCommand( m_CmdOption.GetArg0().c_str() );
	procStart.AddArg( "/standalone" );
	if ( !rfile.empty() ) {
		string w;
		char buf[15];

		w = string( "/file:" ) + rfile;
		procStart.AddArg( w.c_str() );

		snprintf( buf, 15, "%d", Line );
		w = string( "/line:" ) + string( buf );
		procStart.AddArg( w.c_str() );

		if ( rEncode.length() > 0 ) {
			w = string( "/encode:" ) + rEncode;
			procStart.AddArg( w.c_str() );
		}

		if ( LangType.length() > 0 ) {
			w = string( "/syntax:" ) + LangType;
			procStart.AddArg( w.c_str() );
		}
	}

	// ץư
	if ( procStart.Start() < 0 ) {
		ShowErrorMsgBox( pConfigInfo->RefFailToGetPID() );
		return false;
	}
	return true;
}

// ư¸ѤΥޤΥȥ
void CTaEditShell::OnAutoSaveTimer( XtPointer client_data, XtIntervalId *timer )
{
	reinterpret_cast< CTaEditShell* >( client_data )->OnAutoSaveTimer();
}

// ư¸ѤΥޥ٥
void CTaEditShell::OnAutoSaveTimer()
{
	const string fname = theDocument.GetFileName();
	enumAUTOSAVE_NEWFILE asnw = pConfigInfo->GetAutoSaveNewFileMethod();

	// ɥȤƤʤС¸ϹԤʤ
	if ( !theDocument.GetIsModify() ) goto EXIT_LB;

	// ե̾ʤե̾ʤȤˤϤʤˤ⤷ʤˤʤäƤϡ
	// Ԥʤ
	if ( fname.empty() && asnw == ASNW_NOTHING ) goto EXIT_LB;

	// 뤬̵ˤʤäƤʥåܥåɽƤˤ
	// ġե̾ʤϡʤ
	if ( !XtIsSensitive( m_TaEditShell ) && fname.empty() ) goto EXIT_LB;

	// ¸Ԥ
	SaveFileProcedure();

EXIT_LB:

	// Υޤꤹ
	XtAppAddTimeOut( XtWidgetToApplicationContext( m_TaEditShell ),
		pConfigInfo->GetAutoSaveInterval() * 1000, CTaEditShell::OnAutoSaveTimer, this );
}

// ѥޤٱ䤵
void CTaEditShell::DelayCursorTimer()
{
	XtAppContext appContext = XtWidgetToApplicationContext( m_TaEditShell );
	// ѥޤ򤤤ä˴ơϿľ
	XtRemoveTimeOut( CursorTimerID );
	CursorTimerID = XtAppAddTimeOut( appContext, 500, CTaEditShell::OnTimer, this );
}

// ȥꤷľ
void CTaEditShell::ResetTitle( unsigned int reason ) const
{
	Arg al[3];
	int ac = 0;

	// ȥȥꤹʸ
	string TitleStr = TitleMgr.GetTitleStr( reason );
	string IconStr = TitleMgr.GetIconName( reason );

	// ꥽ꤹ
	if ( !TitleStr.empty() ) {
		XtSetArg( al[ac], XmNtitle, TitleStr.c_str() );
		ac++;
	}

	if ( !IconStr.empty() ) {
		XtSetArg( al[ac], XmNiconName, IconStr.c_str() );
		ac++;
	}
	if ( ac > 0 )
		XtSetValues( m_TaEditShell, al, ac );
}

// ץλ
void CTaEditShell::ExitProcess( int r )
{
	// Фˡץλ뤳ȤΤ
	if ( pConstruction ) {

		CErrorBool sr = pConstruction->OnExit();
		if ( !sr ) ProcErrorMsg( sr );

		// 󥹥ȥ饯󡦥֥Ȥ˴
		delete pConstruction;
		pConstruction = NULL;
	}

	// ӥ塼˽λΤ
	m_Draw->OnExit();

	if ( pLangConfig )
		delete pLangConfig;
	pLangConfig = NULL;
	pConfigInfo = NULL;

	exit( r );
}

// ꤷֹذư
void CTaEditShell::MoveTo( int Line )
{
	m_Draw->GetTextEditor()->OnMoveto( Line );
}

// 󥹥ȥ饯󡦥⡼ɤݤ
bool CTaEditShell::IsConstructionMode() const
{
	return pConstruction != NULL;
}

// ɥ󡦥⡼ɤˤ
CErrorBool CTaEditShell::SetStandaloneMode()
{
	CErrorBool r;

	if ( !pConstruction ) return true;

	r = pConstruction->NoticeUnJoin();

	delete pConstruction;
	pConstruction = NULL;

	SetCSModeMenu();
	return r;
}

// 󥹥ȥ饯󡦥⡼ɤˤ
CErrorBool CTaEditShell::SetConstructionMode()
{
	CErrorBool r;

	if ( pConstruction ) return true;

	pConstruction = new CConsruction();
	if ( !pConstruction ) {
		r = pConfigInfo->RefOutOfMemoryErrorMsg();
		goto ERR_EXIT;
	}

	if ( !pConstruction->Initialize() ) {
		// ˼Ԥ
		r = pConfigInfo->RefFailedToInitConstructionModeMsg();
		goto ERR_EXIT;
	}

	r = pConstruction->NoticeJoin( theDocument.GetFileName() );
	if ( !r ) goto ERR_EXIT;
	SetCSModeMenu();
	return true;

ERR_EXIT:
	delete pConstruction;
	pConstruction = NULL;
	SetCSModeMenu();
	return r;
}

// 󥹥ȥ饯󡿥ɥ⡼ɤΥ˥塼ꤹ
void CTaEditShell::SetCSModeMenu() const
{
	int ac = 0;
	Arg al[5];
	XtCallbackList cbList = NULL;
	
	// öХå̵
	ac = 0;
	XtSetArg( al[ac], XmCValueChangedCallback, &cbList ); ac++;
	XtGetValues( m_menuCSModeStandalone, al, ac );
	ac = 0;
	XtSetArg( al[ac], XmCValueChangedCallback, NULL ); ac++;
	XtSetValues( m_menuCSModeStandalone, al, ac );

	// 饸ܥꤹ
	ac = 0;
	XtSetArg( al[ac], XmNset, False ); ac++;
	if ( pConstruction )
		XtSetValues( m_menuCSModeStandalone, al, ac );
	else
		XtSetValues( m_menuCSModeConstruction, al, ac );

	ac = 0;
	XtSetArg( al[ac], XmNset, True ); ac++;
	if ( pConstruction )
		XtSetValues( m_menuCSModeConstruction, al, ac );
	else
		XtSetValues( m_menuCSModeStandalone, al, ac );

	// Хå򸵤᤹
	ac = 0;
	XtSetArg( al[ac], XmCValueChangedCallback, cbList ); ac++;
	XtSetValues( m_menuCSModeStandalone, al, ac );
}
